//---------------------------------------------------------------------------

#ifndef gateUnit1H
#define gateUnit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ScktComp.hpp>

#include <inifiles.hpp>
#include <ExtCtrls.hpp>
#include <vector>

#include <J:/user/lib/oauth/create_oauth.h>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TServerSocket *ServerSocket;
    TClientSocket *TwitterSocket;
	TPageControl *MainPageList;
	TTabSheet *Sheet_server_recv;
	TTabSheet *Sheet_twitter_send;
	TTabSheet *Sheet_twitter_recv;
	TMemo *Memo_server_recv;
	TMemo *Memo_twitter_send;
	TMemo *Memo_twitter_recv;
	TLabel *LServer;
	TLabel *Label1;
    TLabel *Label2;
    TLabel *LTwitter;
    TMemo *EdBody;
    TLabel *Label4;
	void __fastcall ServerSocketClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ServerSocketClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall ServerSocketClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall TwitterSocketConnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall TwitterSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall TwitterSocketError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode);
    void __fastcall TwitterSocketRead(TObject *Sender,
          TCustomWinSocket *Socket);
private:	// [U[錾
	TCustomWinSocket *server;
	TCustomWinSocket *client;
	OAuthDataDef mine;
	bool postPresent;
	bool authPresent;
    AnsiString ID_Pass;

    bool canPost;

	int lineCount;
	int freeRun;
	volatile bool isConnect;
    volatile bool isConnectTwitter;
    volatile bool isSocktError;

	AnsiString serveRrecvLine;

	void __fastcall makeToHeader(AnsiString lines);
	void __fastcall sendToClient(TCustomWinSocket *client, AnsiString line);
    void __fastcall sendTwitter();

    std::vector<AnsiString> sendTwitterLine;
    AnsiString body;


public:		// [U[錾
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
